                   // Copyright (c) 2011-2014 Partner400                                    
                   // All rights reserved.                                                        
                   //                                                                             
                   // Redistribution and use in source and binary forms, with or without          
                   // modification, are permitted provided that the following conditions          
                   // are met:                                                                    
                   // 1. Redistributions of source code must retain the above copyright           
                   //    notice, this list of conditions and the following disclaimer.            
                   // 2. Redistributions in binary form must reproduce the above copyright        
                   //    notice, this list of conditions and the following disclaimer in the
                   //    documentation and/or other materials provided with the distribution.     
                   //                                                                             
                   // THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ''AS IS'' AND      
                   // ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       
                   // IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  
                   // ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     
                   // FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  
                   // DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     
                   // OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       
                   // HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  
                   // LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   
                   // OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      
                   // SUCH DAMAGE.                                                                
                   //                                                                             

000100141130     H DftActGrp(*No) Option(*SrcStmt: *NoDebugIO)
000101141130
000106141130       // Standard IBM supplied Open Access definitions
000107141130      /Copy QRNOPENACC
000108141130
000109141130       // Copy constants for RPG status codes - write your own or use mine
000110141130       //   email me at Contact at Partner400 dot com for a copy
000111141201      /Copy ExtraSrc,StatusCds
000112141201
000113141201       // Standard IBM supplied IFS prototypes
000114141201      /copy qsysinc/qrpglesrc,ifs
000115141201
000117141130       // Protos for program and local procedures - not needed V7+
000118141201     D OpenFile        Pr                  Like(stateInfo.IFShandle)
000119141130
000120141130     D CloseFile       Pr
000121141201     D   handle                            Like(stateInfo.IFShandle)
000122141201
000123141130       // Change to PR to use ExtProc etc. if required
000124141130(A)  D IFSHandlerV2    Pr                  ExtPgm('IFSHANDLR2')
000125141130     D   info                              likeds(QrnOpenAccess_T)
000126141130
000127141130       // The following is the definition of the additional user parameter.
000128141130       //   Add any fields etc here as required. Good idea to have the actual
000129141130       //   definitions t in a /Copy so the user program can use the same ones.
000130141130     D userData        ds                  Based(info.userArea) Qualified
000131141130(B)   /Copy ExtraSrc,IFSPARMDTL
000132141130
000133141130       // Use either the input and/or output buffer definitions or
000134141130       // the Names/Values structure as required
000135141130
000136141130     D nvInput         ds                  likeds(QrnNamesValues_T)
000137141130     D                                     based(info.NamesValues)
000138141130
000139141130       // For Name/Value you'll also need this field to map the values
000140141130       //   Set the pointer in the Select logic for the I/O ops that need it       //
000141141130     D value           s          32470a   Based(pvalue)
000142141130
000143141130       // State info - automatically mapped via info.stateInfo pointer
000144141130(C)  D stateInfo       DS                  Based(info.stateInfo) Qualified
000145141130       // This is where you define any fields you need to preserve
000146141130       //   for a specific file
000147141130     D   IFShandle                   10i 0
000148141130      /Copy ExtraSrc,IFSPARMDTL
000149141130
000150141130       // Procedure interface for program - only a single parameter
000151141130(D)  D IFSHandlerV2    PI
000152141130     D   info                              likeds(QrnOpenAccess_T)
000153141130
000154141130       Select;
000155141130
000156141130(E)      When info.rpgOperation = QrnOperation_WRITE;
000157141130
000158141130            // Write error is unlikely but signal it if it occurs
000159141201            If ( writeFile(stateInfo.IFShandle) < 0 );
000160141130               dsply ('Error on IFS file write');
000161141130               info.rpgStatus = errIO;
000162141130            EndIf;
000163141130
000164141130       // This is where you add any WHEN clauses for all required
000165141130       // operations such as READ, CHAIN, SETLL, etc.
000166141130       // Code is already in place for Open and close operations
000167141130
000168141130         When (info.rpgOperation = QrnOperation_OPEN);
000169141130           OpenFile();
000170141130         When (info.rpgOperation = QrnOperation_CLOSE);
000171141201           CloseFile(stateInfo.IFShandle);
000172141130
000173141130       // This section, processes op-codes the handler is not designed for.
000174141130       // You must report the error to RPG and should log something.
000175141130       // A real production handler would also report the actual
000176141130       //   operation that was being attempted.
000177141130         Other;
000178141130           Dsply ('Unsupported I/O op. ' + %Char(info.rpgOperation)
000179141130                + ' on file ' + info.externalFile.name );
000180141130           info.rpgStatus = errIO;
000181141130       EndSl;
000182141130
000183141130       Return;
000184141130
000185141130       // Basic outline logic for Open function
000186141130     P OpenFile        B
000187141130     D                 PI                  Like(stateInfo.IFShandle)
000188141201
000189141201       // Specify that we want to use Name/Value information
000190141201       info.useNamesValues = *On;
000191141201
000192141130       // If no state info area yet allocate now and initialize
000193141130       If info.stateInfo = *null;
000194141130         info.stateInfo = %Alloc( %Size(stateInfo));
000195141130         Clear stateInfo;
000196141130       EndIf;
000197141130
000198141130       // Check if user parm was supplied and any set defaults if needed
000199141130       // Store parm values in state info area otherwise if caller
000200141130       //   changes the values it could really mess you up
000201141130(F)    If info.userArea = *Null;
000202141130         stateinfo.headerRow = 'Y';  // Default to producing header row
000203141130         stateinfo.separator = ',';  //   Comma for separator
000204141130         stateinfo.IFSfileName = '/Partner400/' +
000205141201                                 %TrimR(%Subst(info.externalFile: 1 : 10)) +
000206141130                                 '.csv';  // Default from external file name
000207141130       Else;  // Copy supplied definitions into state info area
000208141130         Eval-Corr stateinfo = userData;
000209141130       EndIf;
000210141130
000212141201       stateInfo.IFShandle = open( stateinfo.IFSfileName
000213141201                           :  O_CREAT + O_WRONLY + O_CCSID + O_TRUNC
000214141201                           + O_TEXTDATA + O_TEXT_CREAT
000215141201                           : S_IRUSR + S_IWUSR + S_IRGRP + S_IROTH
000216141201                           : 819
000217141201                           : 0 );
000218141130
000219141201       Return stateInfo.IFShandle;
000220141130
000221141130     P OpenFile        E
000222141130       // Basic outline for file Close operation
000223141130     P CloseFile       B
000224141130     D                 PI
000225141130     D   handle                            Like(stateInfo.IFShandle)
000226141130
000227141130     D rc              s             10i 0
000228141130
000229141130       rc = close(handle); // Close IFS file - rc is just for debugging
000230141130
000231141130       // Release storage holding state information
000232141130       //   and set pointer to null.
000233141130       // That way we can't ever reference it by mistake.
000234141130
000235141130       Dealloc info.stateInfo;
000236141130       info.stateInfo = *null;
000237141130       info.rpgStatus = stsOK;
000238141130
000239141130       Return;
000240141130
000241141130     P CloseFile       E
000242141130
000243141130     P writeFile       b
000244141130     D                 pi                  like(stateInfo.IFShandle)
000245141130     D   handle                            like(stateInfo.IFShandle) value
000246141130
000247141130       // Buffer length is arbitrary but 32K should be big enough
000248141130     D buffer          s          32740a   Varying Inz
000249141130     D header          s          32740a   Varying Inz
000250141130     D i               s              5i 0
000251141130     D reply           s             10i 0
000253141130     D quote           c                   '"'
000254141130     D CRLF            c                   x'0d25'
000255141130
000256141130      /free
000257141130       // Process all fields in record
000258141130       For i = 1 to nvInput.num;
000259141130(G)      If ( stateInfo.headerRow = 'Y' );
000260141201           header += %Trimr(nvInput.field(i).externalName); // Use field name as header
000261141130           If i <> nvInput.num; // Add separator after every field except the last
000262141130             header += stateInfo.separator;
000263141130           Else;                // Last field so write out header
000264141201             header += CRLF; // Add record termination
000265141201             reply = write ( handle: %Addr(header: *Data): %Len(header) );
000266141130             stateInfo.headerRow = 'N'; // And turn off header output
000267141130           EndIf;
000268141130         EndIf;
000269141130
000270141130         pvalue = nvInput.field(i).value; // set up to access data
000271141130
000272141130         If ( nvInput.field(i).dataType = QrnDatatype_Alpha )
000273141130         Or ( nvInput.field(i).dataType = QrnDatatype_AlphaVarying);
000274141130           buffer += quote
000275141130                   + %trimR( %subst( value: 1: nvInput.field(i).valueLenBytes ))
000276141130                   + quote;
000277141130
000278141130         ElseIf ( nvInput.field(i).dataType = QrnDatatype_Decimal );
000279141130           buffer += %subst(value: 1: nvInput.field(i).valueLenBytes);
000280141130
000281141130         ElseIf ( nvInput.field(i).dataType = QrnDatatype_Date );
000282141130           buffer += %subst(value: 1: nvInput.field(i).valueLenBytes);
000283141130
000284141130         EndIf;
000285141130
000286141130         If i <> nvInput.num; // Add comma after every field except the last
000287141130           buffer += stateInfo.separator;
000288141130         EndIf;
000289141130
000290141130       EndFor;
000291141130
000292141130       buffer += CRLF; // Add record termination
000293141130
000294141130       // reply will contain the length of data written or -1 in case of error
000295141130       reply = write ( handle: %Addr(buffer:*Data): %Len(buffer) );
000296141130
000297141130       Return reply;
000298141130
000299141130      /end-free
000300141130     P writeFile       e
000301141130
